#INCLUDE "dcdialog.CH"
#include "appevent.ch"

FUNCTION Main()
/*
This example shows how to move and resize browse columns
and save configuration automatically
*/

LOCAL GetList[0], GetOptions, aDir, aHeadings, i, oBrowse , lRight := .F.

DC_AutoRestoreWindow( { HKEY_LOCAL_MACHINE, ;
   'Software\eXpress++ Demo\Windows' } )

DC_AutoRestoreBrowse( { HKEY_LOCAL_MACHINE, ;
   'Software\eXpress++ Demo\Browses' } )

aDir := Directory()

aHeadings := { 'File;Name', ;
               'File;Size', ;
               'Date;Last;Write', ;
               'Time;Last;Write', ;
               'File;Attr', ;
               'Size;Extend;Attr', ;
               'Create;Date', ;
               'Create;Time', ;
               'Date;Last;Access', ;
               'Time;Last;Access' }

@ 0,0 DCSAY 'Click Right Button in a Column for menu' ;
      SAYSIZE 50 COLOR GRA_CLR_BLUE

@ 1,0 DCBROWSE oBrowse DATA aDir PRESENTATION DC_BrowPres() ;
	ITEMMARKED {|| if(lRight,rightclicked(),'')} ;
      SIZE 400,200 PIXEL FIT ;
      ID 'DIRECTORY_BROWSE' ;
      HEADLINES 3 ;
      RBSELECT ;
      RBDOWN {|| browseMenuBlock(@oBrowse) } 

FOR i := 1 TO Len(aHeadings)
  DCBROWSECOL ELEMENT i HEADER aHeadings[i] ;
     WIDTH 60 PIXEL PARENT oBrowse
NEXT

DCGETOPTIONS ;
   NOMINBUTTON ;
   NOMAXBUTTON ;
   AUTORESIZE ;
   BUTTONALIGN DCGUI_BUTTONALIGN_CENTER

DCREAD GUI ;
   FIT ;
   BUTTONS DCGUI_BUTTON_OK ;
   OPTIONS GetOptions ;
   TITLE 'Directory Browse' ;
   MODAL ;
   SETAPPWINDOW HANDLER TESTHANDLER

RETURN nil

* -------------

STATIC FUNCTION BrowseMenu( oBrowse )

STATIC soMenu, soBrowse

LOCAL GetList[0], i

IF Valtype(soMenu) # 'O' .OR. soMenu:status()<=0 .OR. soBrowse # oBrowse

  IF Valtype(soMenu) = 'O'
    soMenu := nil
  ENDIF

  soBrowse := oBrowse

  DCSUBMENU soMenu

    DCMENUITEM 'Move Column &Left' PARENT soMenu ACTION {||soBrowse:moveColumn(-1)}
    DCMENUITEM 'Move Column &Right' PARENT soMenu ACTION {||soBrowse:moveColumn(1)}
    DCMENUITEM SEPARATOR PARENT soMenu
    DCMENUITEM 'Restore Defaults' PARENT soMenu ACTION {||soBrowse:restoreDefaults()}

  DCREAD GUI ;
    PARENT oBrowse ;
    EXIT

ENDIF

RETURN soMenu

* --------------

STATIC FUNCTION BrowseMenuBlock( oBrowse )

wtf 'rbdown'
sleep(100)

RETURN .T.

/*{|x,y,z,o|o := BrowseMenu( oBrowse ), ;
                                o:popup( nil, x, 1 , ;
                                XBPMENU_PU_DEFAULT + XBPMENU_PU_MOUSE_RBDOWN ) }
*/

* -------------

PROC appsys ; RETURN

function rightclicked()
    wtf 'right clicked'
return nil

function testhandler( nEvent, mp1, mp2, oXbp)

IF nEvent = xbeM_RbDown .and. oXbp:ClassName() = 'XbpCellGroup'
	wtf 'rbdown in handler'
	sleep(100)
endif
IF nEvent = xbeM_RbUp .and. oXbp:ClassName() = 'XbpCellGroup'
	wtf 'rbup in handler'
	sleep(100)
endif
return DCGUI_NONE
